import exifread
import os
import csv


class SaveExif2Csv:
    def traverse(self, path):
        fileList = []
        if not os.path.isdir(path):
            fileList.append(path)
            return fileList
        fs = os.listdir(path)
        for f1 in fs:
            tmp_path = os.path.join(path, f1)
            if not os.path.isdir(tmp_path):
                fileList.append(tmp_path)
        return fileList

    def write_csv_single_line(self, tags, writer):
        combo_text = {}
        for tag in tags.keys():
            if tag not in ('JPEGThumbnail', 'TIFFThumbnail', 'Filename', 'EXIF MakerNote'):
                combo_text[tag] = str(tags[tag])
                # print(" %s: %s" % (tag, tags[tag]))
        writer.writerow(combo_text)
    def start(self):
        try:
            input_path = input("请拖入/输入 文件/文件夹路径：\n")
            f1 = open('PicInfo.csv', 'w')
            fileList = traverse(input_path)
            all_info = []
            headers = ["Path"];
            #获取到所有的信息
            for item in fileList:
                # Open image file for reading (binary mode)
                f = open(item, 'rb')
                # Return Exif tags
                tags = exifread.process_file(f)
                tags["Path"] = item
                all_info.append(tags)
            # 因为要写入CSV, 所以要先获取到所有的csv头
            for item in all_info:
                for key in item.keys():
                    if not (key in headers):
                        headers.append(key)
            # 写入CSV
            writer = csv.DictWriter(f1, headers)
            writer.writeheader()
            for item in all_info:
                write_csv_single_line(item, writer)
            print("Success! please see the file .....PicInfo.csv")
        except Exception as err:
            print("Error")
        self.start()

